Index: gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MatServlet.java
===================================================================
--- gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MatServlet.java	(revision 22186)
+++ gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MatServlet.java	(revision 22203)
@@ -58,5 +58,5 @@
 	out.println(h1String);
 	out.println("<p>"+description+"</p>");
-	out.println("<div><form method=\"post\" action=\"http://"+hostName+":"+port_number+"/mat/analyse\">");
+	out.println("<div><form method=\"post\" action=\"http://"+hostName+":"+port_number+"/greenstone3/mat\">");
 
 	out.println("<p>OAI URL: <input type=\"text\" name=\"oaiurl\" size=\"140\"></p>"); 
@@ -318,5 +318,5 @@
 		    
 		    out.println("<p>Choose one metadata prefix to use:</p>");
-		    out.println("<form method=\"post\" action=\"http://"+hostName+":"+port_number+"/mat/analyse\">");
+		    out.println("<form method=\"post\" action=\"http://"+hostName+":"+port_number+"/greenstone3/mat\">");
 		    out.println("<table rules =\"none\">");
 		    
@@ -426,5 +426,5 @@
 	out.println("<p>Building collection...</p>");
 	
-	String host = "http://"+hostName+":"+port_number+"/mat/";
+	String host = "http://"+hostName+":"+port_number+"/greenstone3/mat/";
 	
 	out.println("<form method=\"post\" name=\"aForm\">");
@@ -819,5 +819,5 @@
 	    if(status){
 		    
-	    	out.println("<script type=\"text/javascript\" language=\"JavaScript\"    src = \"http://"+hostName+":"+port_number+"/mat/script/getInfomation.js\">");
+	    	out.println("<script type=\"text/javascript\" language=\"JavaScript\"    src = \"http://"+hostName+":"+port_number+"/greenstone3/mat/script/getInfomation.js\">");
 	    	out.println("reconfig();");
 	    	out.println("</script>");
@@ -861,6 +861,6 @@
 	    titleString ="<title>"+ prop.getProperty("Servlet.Title")+"</title>";
 	    h1String ="<h2>"+ prop.getProperty("Servlet.Head")+"</h2>";
-	    cssString = "<link rel=\"stylesheet\" href=\"http://"+hostName+":"+port_number+"/mat/script/mat.css\" type=\"text/css\" >";
-	    javaScript = "<script type=\"text/javascript\" src=\"http://"+hostName+":"+port_number+"/mat/script/status3.js\"></script>";;
+	    cssString = "<link rel=\"stylesheet\" href=\"http://"+hostName+":"+port_number+"/greenstone3/mat/script/mat.css\" type=\"text/css\" >";
+	    javaScript = "<script type=\"text/javascript\" src=\"http://"+hostName+":"+port_number+"/greenstone3/mat/script/status3.js\"></script>";;
 	    headerString2 = "<head>" + titleString + "\n" +  javaScript + cssString+"</head>\n";
 	    headerString ="<head>" + titleString + "\n" + cssString + "</head>\n";
Index: gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MetadataStats.java
===================================================================
--- gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MetadataStats.java	(revision 22186)
+++ gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MetadataStats.java	(revision 22203)
@@ -96,5 +96,5 @@
     	pw = out;
 
-	destination = globalProperty.getGSDL3Home() + fileSeparator + ".." + fileSeparator + "ext" + fileSeparator + "mat" + fileSeparator + "web" + fileSeparator + collection + fileSeparator;
+	destination = globalProperty.getGSDL3Home() + fileSeparator + "mat" + fileSeparator + collection + fileSeparator;
 	HTMLDirectory = destination;
         StatsDirectory = HTMLDirectory+"metadataStats"+fileSeparator;
Index: gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/PrintHTML.java
===================================================================
--- gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/PrintHTML.java	(revision 22186)
+++ gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/PrintHTML.java	(revision 22203)
@@ -77,5 +77,5 @@
 	}
 	
-	cssString = "<link rel=\"stylesheet\" href=\"http://"+hostName+":"+port_number+"/mat/script/mat.css\" type=\"text/css\" >";
+	cssString = "<link rel=\"stylesheet\" href=\"http://"+hostName+":"+port_number+"/greenstone3/mat/script/mat.css\" type=\"text/css\" >";
     }
 	
@@ -907,5 +907,5 @@
     	    out.write("</head>\r\n");
 	    out.write("<body>\r\n");
-    	    out.write ("<td> <div style=\"float:left;\"> <a href=\"http://"+hostName+":"+port_number+"/mat\">Mat Home</a></div>");
+    	    out.write ("<td> <div style=\"float:left;\"> <a href=\"http://"+hostName+":"+port_number+"/greenstone3/mat\">Mat Home</a></div>");
     	    out.write("<div style=\"float:right;\"><a href=\"http://chnm.gmu.edu/tools/surveys/4386/\">Please send feedback about the Mat tool</a></div></td><br>");
     	    out.write("<h3 align=\"center\">Summary</h3>\r\n");
@@ -1121,5 +1121,5 @@
     	    out.write("body{font-family: Arial;}\r\n");
     	    out.write("</style>\r\n");
-    	    out.write("<script type=\"text/javascript\" src=\"http://"+hostName+":"+port_number+"/mat/script/status3.js\"></script>");
+    	    out.write("<script type=\"text/javascript\" src=\"http://"+hostName+":"+port_number+"/greenstone3/mat/script/status3.js\"></script>");
     	    out.write("</head>\r\n");
 	    out.write("<body>\r\n");
@@ -2128,6 +2128,6 @@
     private void setupMetadataLink(String fileName){
     	
-    	String destination = globalProperty.getGSDL3Home() + fileSeparator + ".." + fileSeparator + "ext" + fileSeparator + "mat" + fileSeparator + "web" + fileSeparator + "script" + fileSeparator+fileName + ".xml";
-    	   
+	String destination = globalProperty.getGSDL3Home() + fileSeparator + "mat" + fileSeparator + "script" + fileSeparator + fileName + ".xml";
+ 
     	try{
 	    DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();