Index: /gs2-extensions/open-office/trunk/COMPILE-INSTALL.sh
===================================================================
--- /gs2-extensions/open-office/trunk/COMPILE-INSTALL.sh	(revision 22204)
+++ /gs2-extensions/open-office/trunk/COMPILE-INSTALL.sh	(revision 22204)
@@ -0,0 +1,32 @@
+#!/bin/bash
+
+
+source setup.bash
+
+export JOD_CONVERTER=jodconverter-core-3.0-beta-3
+
+
+if [ "x$GEXTOOFFICE" != "x" ] ; then
+  echo Compiling Code
+
+  pushd "$GEXTOOFFICE/build-srcpack/packages" 
+
+  ./COMPILE-INSTALL.sh 
+
+  popd
+
+  if [ ! -d lib/java ] ; then
+    echo ""
+    echo "Creating lib/java"
+    mkdir -p lib/java
+  fi
+
+  echo ""
+  echo "Installing jodconverter.jar into lib/java"
+  /bin/cp -r $GEXTOOFFICE/build-srcpack/packages/$JOD_CONVERTER/jodconverter.jar lib/java/.
+
+
+else 
+  echo "Error: Environment variable GEXTOOFICE is not set"
+fi
+
Index: /gs2-extensions/open-office/trunk/RUN.sh
===================================================================
--- /gs2-extensions/open-office/trunk/RUN.sh	(revision 22204)
+++ /gs2-extensions/open-office/trunk/RUN.sh	(revision 22204)
@@ -0,0 +1,22 @@
+#!/bin/bash
+
+
+#pushd "$GSEXTOOFFICE/jodconverter-core-3.0-beta-3" 
+
+#cp=`ls lib/*.jar | tr '\n' ':'`
+
+#java -cp ".:$cp" org.artofsolving.jodconverter.cli.Convert $*
+
+#popd
+
+which cygpath >/dev/null 2>&1
+
+if [ $? = "0" ] ; then
+  # Running on Cygwin
+  java -jar lib\\java\\jodconverter.jar $*
+else
+  java -jar lib/java/jodconverter.jar $*
+fi
+
+
+
Index: /gs2-extensions/open-office/trunk/START-UP.sh
===================================================================
--- /gs2-extensions/open-office/trunk/START-UP.sh	(revision 22204)
+++ /gs2-extensions/open-office/trunk/START-UP.sh	(revision 22204)
@@ -0,0 +1,20 @@
+#!/bin/bash
+
+which soffice >/dev/null 2>&1 
+if [ $? = 0 ] ; then
+
+  echo "Starting up Open Office Server (headless mode)"
+
+  soffice "-accept=socket,host=localhost,port=8100;urp;StarOffice.ServiceManager" -nologo -headless
+
+  echo "Testing to see if soffice is listening on port 8100"
+
+  netstat -an | grep 8100
+else 
+  echo ""
+  echo "Error: Unable to find 'soffice' on PATH environment variable"
+  echo ""
+fi
+
+
+
Index: /gs2-extensions/open-office/trunk/build-srcpack/packages/COMPILE-INSTALL.sh
===================================================================
--- /gs2-extensions/open-office/trunk/build-srcpack/packages/COMPILE-INSTALL.sh	(revision 22204)
+++ /gs2-extensions/open-office/trunk/build-srcpack/packages/COMPILE-INSTALL.sh	(revision 22204)
@@ -0,0 +1,36 @@
+#!/bin/bash
+
+
+if [ ! -e "$JOD_CONVERTER" ] ; then
+  echo "Unzipping JodConverter Core"
+  unzip "$JOD_CONVERTER-dist.zip"
+
+  cd "$JOD_CONVERTER" \
+   && jar xvf "$JOD_CONVERTER-sources.jar" \
+   && cd ..
+fi
+
+
+cd "$JOD_CONVERTER"
+
+which cygpath >/dev/null 2>&1
+if [ $? = "0" ] ; then
+  # Running under cygwin
+  cp=`ls lib/*.jar | tr '\n' ';'`
+else
+  cp=`ls lib/*.jar | tr '\n' ':'`
+fi
+
+cp_with_spaces=`ls lib/*.jar | tr '\n' ' '`
+
+javac -cp ".:$cp" org/artofsolving/jodconverter/cli/Convert.java \
+  && \
+echo "Manifest-Version: 1.0" > Manifest.txt && \
+echo "Created-By: Greenstone Digital Library Project" >> Manifest.txt && \
+echo "Main-Class: org.artofsolving.jodconverter.cli.Convert" >> Manifest.txt && \
+echo "Class-Path: $cp_with_spaces" >> Manifest.txt \
+ && \
+jar cvfm jodconverter.jar Manifest.txt org lib conf document-formats.js
+
+cd ..
+
Index: /gs2-extensions/open-office/trunk/setup.bash
===================================================================
--- /gs2-extensions/open-office/trunk/setup.bash	(revision 22204)
+++ /gs2-extensions/open-office/trunk/setup.bash	(revision 22204)
@@ -0,0 +1,19 @@
+
+extdesc="the Open Office Extension"
+
+##source cascade-make/lib/cascade-lib.bash
+
+if [ "x$GEXTOOFFICE" = "x" ] ; then
+  export GEXTOOFFICE=`pwd`
+
+  if [ "x$GSDLEXTS" = "x" ] ; then
+    export GSDLEXTS=open-office
+  else 
+    export GSDLEXTS=$GSDLEXTS:open-office
+  fi
+
+
+  echo "+Your environment is now setup for $extdesc"
+else
+  echo "+Your environment is already setup for $extdesc"
+fi