Index: /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE.sh
===================================================================
--- /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE.sh	(revision 22233)
+++ /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE.sh	(revision 22234)
@@ -2,5 +2,5 @@
 
 
-for d in MYSQL LIBPNG APACHE-PASS1 PHP APACHE-PASS2  ; do
+for d in MYSQL LIBPNG APACHE-PASS1 PHP  ; do
   echo "    Running CASCADE-MAKE/$d.sh $*"
 
Index: /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS1.sh
===================================================================
--- /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS1.sh	(revision 22233)
+++ /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS1.sh	(revision 22234)
@@ -1,6 +1,6 @@
 #!/bin/bash
 
-package=apache
-version=_1.3.41
+package=httpd
+version=-2.2.15
 
 progname=$0
@@ -11,10 +11,19 @@
 prefix=$GEXTAMP_INSTALLED
 
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_configure $force_config $auto_config $package $version "$prefix" \
-  --with-layout=Apache 
+if [ $COMPILE_UP_APACHE_HTTPD = "1" ] ; then
+  opt_run_untar $force_untar $auto_untar $package $version
+  opt_run_configure $force_config $auto_config $package $version "$prefix" \
+    "--with-layout=Apache \
+     --enable-so"
 
+  opt_run_make $compile   $package $version
+  opt_run_make $install   $package $version "install"
+  opt_run_make $clean     $package $version "clean"
+  opt_run_make $distclean $package $version "distclean"
 
-
-
-
+  opt_run_tarclean $tarclean $package $version
+else
+  echo "Using Apache HTTPD that is provided externally to the extension at:"
+  echo "  $APACHE_HTTPD_HOME"
+  echo ""
+fi
Index: /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS2.sh
===================================================================
--- /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS2.sh	(revision 22233)
+++ /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS2.sh	(revision 22234)
@@ -1,6 +1,6 @@
 #!/bin/bash
 
-package=apache
-version=_1.3.41
+package=httpd
+version=-2.2.15
 
 progname=$0
Index: /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/MYSQL.sh
===================================================================
--- /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/MYSQL.sh	(revision 22233)
+++ /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/MYSQL.sh	(revision 22234)
@@ -2,5 +2,5 @@
 
 package=mysql
-version=-5.1.26-rc
+version=-5.1.47
 
 progname=$0
Index: /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/PHP.sh
===================================================================
--- /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/PHP.sh	(revision 22233)
+++ /gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/PHP.sh	(revision 22234)
@@ -2,7 +2,7 @@
 
 package=php
-version=-5.2.6
+version=-5.3.2
 
-apache_version=apache_1.3.41
+apache_version=httpd-2.2.15
 
 progname=$0
@@ -18,7 +18,9 @@
   "--with-mysql=$prefix \
    --with-png-dir=$prefix \
-   --with-apache=../$apache_version \
+   --with-apxs2=$prefix/bin/apxs \
    --with-gd"
 
+# --with-apxs2 \
+# --with-apache=../$apache_version \
 # --with-jpeg-dir=/usr/local/ --with-zlib-
 
Index: /gs2-extensions/gsdl-amp/trunk/setup.bash
===================================================================
--- /gs2-extensions/gsdl-amp/trunk/setup.bash	(revision 22233)
+++ /gs2-extensions/gsdl-amp/trunk/setup.bash	(revision 22234)
@@ -16,8 +16,24 @@
   fi
 
+
+  export APACHE_HTTPD_HOME="$GEXTAMP_INSTALLED";
+  export COMPILE_UP_APACHE_HTTPD=1
+
+  if [ -n "$GSDLHOME" ] ; then
+      # see if there is already an apache httpd we can use
+      # override default values if there is
+      if [ -e "$GSDLHOME/apache-httpd/$GSDLOS" ] ; then
+	  export APACHE_HTTPD_HOME="$GSDLHOME/apache-httpd/$GSDLOS";
+	  export COMPILE_UP_APACHE_HTTPD=0
+      fi
+  if
+
+
+  extdir=${GEXTAMP##*/}
+
   if [ "x$GSDLEXTS" = "x" ] ; then
-    export GSDLEXTS=amp
+    export GSDLEXTS=$extdir
   else 
-    export GSDLEXTS=$GSDLEXTS:amp
+    export GSDLEXTS=$GSDLEXTS:$extdir
   fi
 